module(...,package.seeall)

--TODO get some orbital spin up in this
--TODO hook up conductor
--TODO optimise code

local flip = short.flip

function createSolar()
    local seed = os.time()
    reseed(seed)
    print(seed)

    local solar = {}

    --local scaleMod = _W/20
    local scaleMod = 5
    local startDistMod = _W/4
    local fieldDenseBase = 25
    local fieldDenseMod = 1
    local moonDeathForce = 100
    local minAlpha = 0.75
    local sunFreq = 10

    solar.sunOrbit = display.newGroup()
    --solar.sun = display.newImage("images/sun.png", _W*scaleMod, _W*scaleMod)
    solar.sun = display.newImage("images/sun.png", _W, _W)

    solar.sun.type = "sun"
    --solar.sun.mass = 333000
    solar.sun.timeToBang = mRand(30, 100)
    solar.sun.time = 0
    local sw = solar.sun.width*solar.sun.xScale/2
    local sh = solar.sun.height*solar.sun.yScale/2
    local corners = {-sw,-sh,sw,-sh,sw,sh,-sw,sh}
    sw = nil
    sh = nil
    solar.sun.isBullet = true
    physics.addBody(solar.sun, "dynamic", {density="1000000000000", shape=corners})
    function solar.sun:implode()
        --LODO IMPLODE THAT FUCKER
    end
    function solar.sun:bang()
        --LODO add some fancy effects and shit
        if(solar.sun.alpha > minAlpha)then
            solar.sun.alpha = solar.sun.alpha - 0.01
            --solar.sun.density = solar.sun.density - 0.01
        end
        solar.sun.xScale = solar.sun.xScale + 0.05
        solar.sun.yScale = solar.sun.yScale + 0.05

        local sw = solar.sun.width*solar.sun.xScale/2
        local sh = solar.sun.height*solar.sun.yScale/2
        local corners = {-sw,-sh,sw,-sh,sw,sh,-sw,sh}
        sw = nil
        sh = nil
        physics.removeBody(solar.sun)
        physics.addBody(solar.sun, "dynamic", {density="1000000000000", shape=corners})
        --solar.sun.isBullet = true
    end
    function solar.sun:updateSun()
        if(not (solar.sun.time >= solar.sun.timeToBang))then
            solar.sun.time = solar.sun.time + 1
        else
            solar.sun:bang()
            --timer.cancel(solar.sun.timer)
            --solar.sun.timer = nil
            --solar.sun.timer = timer.performWithDelay(sunFreq, solar.sun:bang(), -1)
        end
    end
    solar.sun.timer = timer.performWithDelay(sunFreq, solar.sun:updateSun(), -1)
    solar.sunOrbit:insert(solar.sun)
    solar.sun.x = 0
    solar.sun.y = 0
    solar.sunOrbit.x = _W/2
    solar.sunOrbit.y = _H/2
    solar.sun.timer = timer.performWithDelay(100, solar.sun:updateSun(), -1)
    function solar.sun:postCollision(e)
        if(e.other.type == "player")then
            e.other:die()
        end
    end

    local planSheet = sprite.newSpriteSheetFromData("images/sheet_planets.png", require("sheet_planets").getSpriteSheetData())
    local planSet = sprite.newSpriteSet(planSheet, 1, 5)
    for i=1, 5, 1 do
        sprite.add(planSet, ""..i, i, 1, 1, -1)
    end
    local moonSheet = sprite.newSpriteSheetFromData("images/rocks_mid_sheet.png", require("sheet_mid").getSpriteSheetData())
    local moonSet = sprite.newSpriteSet(moonSheet, 1, 9)
    for i=1, 9, 1 do
        sprite.add(moonSet, ""..i, i, 1, 1, -1)
    end
    local fieldSheet = sprite.newSpriteSheetFromData("images/rocks_small_sheet.png", require("sheet_small").getSpriteSheetData())
    local fieldSet = sprite.newSpriteSet(fieldSheet, 1, 15)
    for i=1, 15, 1 do
        sprite.add(fieldSet, ""..i, i, 1, 1, -1)
    end
    function solar:cleanUp()
        planSheet:dispose()
        moonSheet:dispose()
        fieldSheet:dispose()
    end


    local function genProperties(obj)
        --based on type property generate some stuff

        --[[
        local function dropFuel(e)
            --TODO fix fuel drop
            local function drop()
                local fuel = display.newImage("images/fuel.png", _W/14, _W/10)
                solar.sunOrbit:insert(fuel)
                fuel.x = e.target.x
                fuel.y = e.target.y
                fuel.type = fuel
                function fuel:collision(e)
                    fuel:removeSelf()
                    fuel = nil
                end
                fuel:addEventListener("collision", fuel)
            end
            print(e.target.type)
            if(e.target.type == "moon")then
            --if(e.object1.type == "moon")then
                if(e.force >= moonDeathForce)then
                    drop()
                    e.target:removeSelf()
                end
            else
                drop()
                e.target:removeSelf()
                e.target = nil
            end
        end
        --]]

        local function temp(e)
            if(e.other.type == "player")then
                print("Collision with " .. e.other.type)
                print("collision force: " .. e.force)
            end
        end
        if(obj.type == "planet")then
            --obj.height = mRand(10)/2*scaleMod
            --obj.width = obj.height
            --physics.addBody(obj, "dynamic", {density=mRand(12)/2})
            --obj.xScale = 1 + (mRand(1))
            --obj.yScale = obj.xScale
            obj:setReferencePoint(display.CenterReferencePoint)
            physics.addBody(obj, "dynamic")
            obj:addEventListener("postCollision", temp)
        elseif(obj.type == "field")then
            local density
            if(obj.small == true)then
                density = mRand(1)* fieldDenseBase * fieldDenseMod
            else
                density = fieldDenseBase + mRand(2 * fieldDenseBase) * fieldDenseMod
            end
            for i=1, density, 1 do
                obj[i] = sprite.newSprite(fieldSet)
                obj[i]:prepare(""..mRand(15))
                obj[i]:play()
                obj[i].type = "debris"
                obj[i].xScale = 1
                obj[i].yScale = obj[i].xScale
                obj[i].x = mRand(obj.rad - 1)
                obj[i].y = obj.rad - obj[i].x
                if(flip())then
                    obj[i].x = -obj[i].x
                end
                if(flip())then
                    obj[i].y = -obj[i].y
                end
                physics.addBody(obj[i], "dynamic")
                obj[i]:addEventListener("postCollision", temp)
                --obj[i]:addEventListener("postCollision", dropFuel)
            end
            --TODO collision makes fuel
        elseif(obj.type == "moon")then
            --obj.height = mRand(1)*scaleMod
            --obj.width = obj.height
            --obj.xScale = 1 + mRand(1)
            --obj.yScale = obj.xScale
            obj:setReferencePoint(display.CenterReferencePoint)
            if(flip())then
                obj.x = (10 + mRand(15)) * scaleMod
            else
                obj.x = (-10 - mRand(15)) * scaleMod
            end
            if(flip())then
                obj.y = (10 + mRand(15)) * scaleMod
            else
                obj.y = (-10 - mRand(15)) * scaleMod
            end
            physics.addBody(obj, "dynamic")
            obj:addEventListener("postCollision", temp)
            --obj:addEventListener("postCollision", dropFuel)
        end

        return obj
    end

    local function placePlayer()
        solar.plyr = {}

        local X = mRand((_W*_W)+1 + (startDistMod * startDistMod)) - 1
        local Y = (_W*_W) - X
        X = X + solar.sun.width
        Y = Y + solar.sun.height
        if(X == 0)then
            solar.plyr.x = 0
        else
            solar.plyr.x = math.sqrt(X)
        end
        X = nil
        if(Y == 0)then
            solar.plyr.y = 0
        else
            solar.plyr.y = math.sqrt(Y)
        end
    end

    --local function populate(solar)
    local function populate()
        --determines number of planets, asteroid belts, misc debris
        --each object that can be orbited create a display group for
        --call genProperties() after creating each object

        --planet population code
        solar.planets = {}
        solar.planets.no = 5 + mRand(8)

        for i=1, solar.planets.no, 1 do
            solar.planets[i] = {}
            solar.planets[i].group = display.newGroup()
            solar.planets[i].obj = sprite.newSprite(planSet)
            solar.planets[i].obj:prepare("" .. (mRand(5)))
            solar.planets[i].obj:play()
            --solar.planets[i].obj = display.newCircle(0, 0, 1)
            solar.planets[i].obj:setReferencePoint(display.CenterReferencePoint)
            solar.planets[i].obj.type = "planet"
            solar.planets[i].group:insert(solar.planets[i].obj)
            solar.sunOrbit:insert(solar.planets[i].group)
            if(i == 1)then
                if(flip())then
                    solar.planets[i].group.x = (40 + mRand(25)) * scaleMod
                else
                    solar.planets[i].group.x = (-40 - mRand(25)) * scaleMod
                end
                if(flip())then
                    solar.planets[i].group.y = (40 + mRand(25)) * scaleMod
                else
                    solar.planets[i].group.y = (-40 - mRand(25)) * scaleMod
                end
            else
                local prevX = math.max(solar.planets[i].group.x, -solar.planets[i].group.x)
                local prevY = math.max(solar.planets[i].group.y, -solar.planets[i].group.y)
                if(flip())then
                    solar.planets[i].group.x = (40 + mRand(25)) * scaleMod + prevX
                else
                    solar.planets[i].group.x = (-40 - mRand(25)) * scaleMod - prevX
                end
                if(flip())then
                    solar.planets[i].group.y = (40 + mRand(25)) * scaleMod + prevY
                else
                    solar.planets[i].group.y = (-40 - mRand(25)) * scaleMod - prevY
                end
            end
            solar.planets[i].obj = genProperties(solar.planets[i].obj)
            --physics.addBody(solar.planets[i].obj, "dynamic", {density=mRand(1)*2})
            --Orbital creation code
            solar.planets[i].obj.orbitals = {}
            if(mRand(5) == 5)then
                solar.planets[i].obj.orbitals[1] = {}
                solar.planets[i].obj.orbitals[1].obj = {}
                solar.planets[i].obj.orbitals[1].obj.type = "field"
                solar.planets[i].obj.orbitals[1].obj.small = true
                solar.planets[i].obj.orbitals[1].obj.rad = ((1 + mRand(1))*scaleMod)*solar.planets[i].obj.width
                solar.planets[i].obj.orbitals[1].obj = genProperties(solar.planets[i].obj.orbitals[1].obj)
                solar.planets[i].obj.orbitals[1].group = display.newGroup()
                solar.planets[i].obj.orbitals[1].group.x = solar.planets[i].group.x
                solar.planets[i].obj.orbitals[1].group.y = solar.planets[i].group.y
                for j=1, (#solar.planets[i].obj.orbitals[1].obj), 1 do
                    solar.planets[i].obj.orbitals[1].group:insert(solar.planets[i].obj.orbitals[1].obj[j])
                end
                solar.planets[i].group:insert(solar.planets[i].obj.orbitals[1].group)
            else
                for m=1, (mRand(5) - 1), 1 do
                    solar.planets[i].obj.orbitals[m] = {}
                    solar.planets[i].obj.orbitals[m].obj = sprite.newSprite(moonSet)
                    solar.planets[i].obj.orbitals[m].obj:prepare("" .. (mRand(9)))
                    solar.planets[i].obj.orbitals[m].obj:play()
                    solar.planets[i].obj.orbitals[m].obj.type = "moon"
                    solar.planets[i].obj.orbitals[m].obj = genProperties(solar.planets[i].obj.orbitals[m].obj)
                    --physics.addBody(solar.planets[i].obj.orbitals[m].obj, "dynamic", {density=mRand(1)*2})
                    --solar.planets[i].obj.orbitals[m].obj = display.newCircle(0, 0, 10)
                    solar.planets[i].obj.orbitals[m].group = display.newGroup()
                    solar.planets[i].obj.orbitals[m].group:insert(solar.planets[i].obj.orbitals[m].obj)
                    solar.planets[i].group:insert(solar.planets[i].obj.orbitals[m].group)
                end
            end
        end

        solar.fields = {}

        for f=1, (3 + mRand(3)), 1 do
            solar.fields[f] = {}
            solar.fields[f].group = display.newGroup()
            solar.fields[f].group.x = solar.sunOrbit.x
            solar.fields[f].group.y = solar.sunOrbit.y
            solar.fields[f].obj = {}
            solar.fields[f].obj.type = "field"
            solar.fields[f].obj.rad = (2 * startDistMod) + mRand(_H * 5)
            solar.fields[f].obj = genProperties(solar.fields[f].obj)
            for i=1, #solar.fields[f].obj, 1 do
                solar.fields[f].group:insert(solar.fields[f].obj[i])
            end
            solar.sunOrbit:insert(solar.fields[f].group)
        end

        return solar
    end
    --[[
    function solar:move()

    end
    --]]
    --solar = populate(solar)
    solar = populate()
    placePlayer()

    return solar
end