module(..., package.seeall)

--LODO music button

function new()
    local Scene = display.newGroup()

    local background = display.newGroup()
    local GUI = display.newGroup()

    --[[
    local function footGen()
        local footers = {}

        --needs MOAR quotes

        --include song quotes? this bible stuff sucks

        --maybe this one doesn't work
        --22:5
        footers[1] = "And there shall be no night there\nand they need no candle, neither light of the sun\nfor the Lord God giveth them light:\nand they shall reign for ever and ever"
        --14:7
        footers[2] = "Saying with a loud voice, 'Fear God, and give glory to him\nfor the hour of His judgment is come\nand worship Him that made heaven, and earth, and the sea, and the fountains of waters.'"

        short.reseed()
        return footers[mRand(1, #footers)]
    end
    --]]
    --[[
    local footer = display.newText(footGen(), 0, 0, native.systemFont, 20)
    footer.x = _W/2
    footer.y = (_H + 25) - (footer.height / 2)
    --]]
    --[[
    local title = display.newText("REVELATIONS", 0, 0, native.systemFont, 60)
    title.x = _W/2
    title.y = (title.height / 2) + 15
    local playBtn = display.newText("Play", 0, 0, native.systemFont, 36)
    playBtn.x = _W/2
    playBtn.y = title.y + title.height
    local optionBtn = display.newText("Options", 0, 0, native.systemFont, 36)
    optionBtn.x = _W/2
    optionBtn.y = playBtn.y + playBtn.height
    local exitBtn = display.newText("Quit", 0, 0, native.systemFont, 36)
    exitBtn.x = _W/2
    exitBtn.y = optionBtn.y + optionBtn.height
    --]]

    local title = display.newImage("images/title.png")
    title:setReferencePoint(display.CenterReferencePoint)
    title.rotation = 90
    title.xScale = (_H - (_H/4))/title.width
    title.yScale = _W/10/title.height
    title.x = _W - _W/10
    title.y = _H/2
    GUI:insert(title)

    --LODO if player moves off button before releasing, prevent action
    local function changeScene(e)
        if(e.phase == "began")then
            --e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            --e.target:setTextColor(255,255,255)
        elseif(e.phase == "cancelled" or e.phase == "ended") then
            conductor.playEffect(1)
            background:removeSelf()
            GUI:removeSelf()
            background = nil
            GUI = nil
            director:changeScene(e.target.scene)
        end
    end

    local function common(obj)
        obj:setReferencePoint(display.CenterReferencePoint)
        obj.y = _H/2
        obj.rotation = 90
        obj.xScale = obj.width/(_H/2)
        obj.yScale = obj.height/(_W/3)
    end

    local play = display.newImage("images/btn_play.png")
    common(play)
    play:setReferencePoint(display.CenterReferencePoint)
    play.x = title.x - title.height/2 - play.height/2 - _W/40
    play.scene = "play"
    GUI:insert(play)
    play:addEventListener("touch", changeScene)

    local options = display.newImage("images/btn_options.png")
    common(options)
    options.x = play.x - play.height/2 - _W/20
    options.scene = "options"
    GUI:insert(options)
    options:addEventListener("touch", changeScene)

    local htp = display.newImage("images/btn_guide.png")
    common(htp)
    --htp.x = options.x - options.height/2 - htp.height/2
    htp.x = options.x - options.height/2 - _W/20
    htp.scene = "htp"
    GUI:insert(htp)
    htp:addEventListener("touch", changeScene)

    local credits = display.newImage("images/btn_credits.png")
    common(credits)
    credits.x = htp.x - htp.height/2 - _W/20
    credits.scene = "respect"
    GUI:insert(credits)
    credits:addEventListener("touch", changeScene)

    local exit = display.newImage("images/btn_exit.png")
    common(exit)
    exit.x = credits.x - credits.height/2 - _W/20
    GUI:insert(exit)
    function exit:touch(e)
        if(e.phase == "began")then
            --e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            --e.target:setTextColor(255,255,255)
        elseif(e.phase == "cancelled" or e.phase == "ended") then
            conductor.playEffect(1)
            os.exit()
        end
    end
    exit:addEventListener("touch", exit)

    local back = display.newImage("images/menu_back.png")
    back.alpha = 0.75
    back:setReferencePoint(display.CenterReferencePoint)
    back.x = _W/2
    back.y = _H/2
    back.rotation = 90

    background:insert(back)

    --GUI:insert(footer)

    Scene:insert(background)
    Scene:insert(GUI)

    conductor.menuLoad()

    return Scene
end